package com.bankapp;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Bundle;
import android.os.Handler;
import android.os.HandlerThread;
import android.os.Looper;
import android.os.Message;
import android.text.Editable;
import android.text.TextWatcher;
import android.text.method.PasswordTransformationMethod;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

 /**mainActivity je klasa koja se prvo poziva pri pokretanju aplikacije
*/

public class MainActivity extends Activity {
 
	private TextView poruka;
	private EditText username;
	private EditText password;
	private Button button;
	private String cred_user;
	private String cred_pass;
	Context context;
    boolean isBound = false;
    
    private String result;
    private String credentials;
    ServiceTest service;
    private String publickey=null;
    Activity mActivity;
    ProgressDialog dialog;
    
         // metoda onCreate definiše procese koji se obavljaju pri kreiranju
         // aplikacije
    
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.fragment_main); // naredba setContenView postavlja fragment_main.xml 
                                                // fajl kao layout. U fajlu fragment_main.xml je definisan izgled stranice
		
		username = (EditText) findViewById(R.id.inputusername); // referenca na polje username
		password = (EditText) findViewById (R.id.inputpassword); //referenca na polje password
        poruka = (TextView) findViewById (R.id.poruka);          // referenca na polje poruka
		button = (Button) findViewById(R.id.button1); // referenca na element button
                      

        mActivity = this;        // ovde čuvamo vrednost Activity, da bi kasnije mogli ponovo da pozovemo 
		context = this;          // istu aktivnost
		
		
		// Definišemo Listener koji "osluškuje" da li je dugme pritisnuto i ukoliko jeste pokreće metodu onClick
		
		button.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				

				cred_user = username.getText().toString(); // Uzima vrednost username polja i čuva u promenljivoj cred_user
				username.setText("");                       // Resetuje vrednost polja username na prazan string
				cred_pass = password.getText().toString(); // Uzima vrednost polja passsword i čuva u promenljivoj cred_pass
				password.setText("");                      // Resetuje vrednost polja password na prazan string
                credentials = cred_user + ":" + cred_pass; // pakuje vrednosti username i password u jedan string koji se zatim 
            	                                           // prosleđuje serveru. Vrednosti su razdvojene simbolom ":" 
               
                
                if (!(credentials.equals(":")) ){          // ukoliko je vrednost promenljive credentials različita od ":", znači da je   
                                                           // korisnik uneo podatke.    
               
                
                Thread service = new Thread (new ServiceTest());      // definiše i 
                service.start();                                      // pokreće novu nit ServiceTest, koja komunicira sa serverom
                        
                
                 
                    
                dialog=new ProgressDialog(context);                 // definiše dialog prozor u okviru stranice aplikacije
                dialog.setMessage("Sacekajte...");                  //  setMessage definiše poruku koju će prozor ispisati
                dialog.setCancelable(false);                        //  setCancelable definiše da li se prozor može ugasiti  
                dialog.setInverseBackgroundForced(false);            
                dialog.show();                                      // aktivira dialog
              
               }
               else {
            	   poruka.setText("Niste uneli podatke");           // u slučaju da je vrednost promenljive credentials jednaka ":", korisnik 
               }                                                    // nije uneo podatke.  
                                                                    // poruka.setText upisuje poruku u polje poruka 
			}

		}	
				

		
	);
		} 
	
	// unutrašnja nit ServiceTest klase mainActivity koja implementira interfejs Runnable
	// vrši komunikaciju sa serverom
	
	public class ServiceTest implements Runnable{
		DataOutputStream dataOutputStream;
		DataInputStream dataInputStream;
		private Socket client;
		
		// glavna metoda klase, koja se pokreće metodom service.start();
		
	public void run() {
	
        // otvaranje socketa i povezivanje na server
		if (client == null) {
			try{
				client = new Socket("192.168.1.94", 4444);   
			} catch (UnknownHostException e) {
			
				e.printStackTrace();
				
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	
      //pocetak server-klijent protokola razmene poruka
		
		Security security = new Security();              // definiše novi objekat pomoćne klase Security koja služi za šifrovanje
           SendMessage("Start");                         // šalje komandu serveru, koristeći metodu SendMessage.
           
           while(true)
   		{
           String response = RecieveMessage();            // prihvata poruku od servera. zavisno od naredbe koju je dobio od servera, 
                                                          // skače na odgovarajući deo koda. 
           
           if (response.equals("Start OK")){                                     
        	   
                 publickey = RecieveMessage();              // prihvata javni RSA ključ od servera          
        	     security.setPublicKey(publickey);          // prosleđuje javni RSA ključ klasi security koja ga dalje koristi
              
                 Log.d("publickey", publickey);
              
                 SendMessage("Key");}
              
              
              if (response.equals("Key OK")){
                  

           	   try {
				
           		   SendMessage(security.encryptRSA(security.createKeyForAES()));      // šalje serveru AES ključ enkriptovan RSA ključem
                 		

			} catch (NoSuchAlgorithmException e) {
				e.printStackTrace();
			} catch (NoSuchProviderException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}

              } 	
              
               if (response.equals("Key OK")){

              
        	   SendMessage("LogIn");                              // šalje komandu serveru da se pripremi za prijem kredencijala
        	  

        	   
           }
           
           if (response.equals("LogIn OK")){
         
        	
        	   
        	   try {
				SendMessage(security.encrypt(credentials));        // šalje serveru kredencijale enkriptovane AES ključem
			} catch (Exception e) {
				
				e.printStackTrace();
			} //salje kredencijale
   		
        	   
           }
           
              if (response.equals("Log in FAIL")){                    // ukoliko server vrati komandu da je login neuspešan, ispisuje se poruka
                   
            	  mActivity.runOnUiThread(new Runnable() {             // da bi se ispisala poruka prvo je potrebno vratiti se na UI                   
            		    public void run() {                            // ovde koristimo mActivity promenljivu da pozovemo mainActivity 
            		   dialog.dismiss();                               // gasi dialog prozor
            		 poruka.setText("Uneli ste pogrešne podatke");     // ispisuje poruku o pogrešnom unosu
            		 button.setClickable(true);
            		    }
            		});
            	  break;                                                //iskače iz petlje

           }
           
           
           
           if (response.equals("Log in OK")){
               
   			
   			   SendMessage("ClientData");                                     // šalje komandu serveru da se pripremi za transfer podataka
        	   
           }
           
           if (response.equals("ClientData OK")){
	
		        try {
					SendMessage(security.encrypt(credentials));  // ponovo šalje kredencijale
				} catch (Exception e) {
					
					e.printStackTrace();
				} 
		        
		        String res = RecieveMessage();                    //dobija rezultat iz baze od servera koji je enkriptovan
		        
		        try {
					result = security.decrypt(res);               // dekriptuje dobijeni rezultat    
				} catch (Exception e) {
					
					e.printStackTrace();
				}
		        
	   			   SendMessage("End");}                           // šalje komandu za završetak komunikacije

	   			if (response.equals("End OK")){
	               
	                
	   				Intent intent = new Intent(MainActivity.this, Second_page.class);    //definišemo Intent za prebacivanje sa jedne stranice na drugu
	                intent.putExtra("message", result);                                  // putExtra omogućava da se prenesu podaci 
	                startActivity(intent);                                                
	   	            finish();  			                                                 // poziva metodu onDestroy, koja gasi ovaj Activity
	    			 break;
	         	   
	            }
	   			   
              }
           
           
   		}
        
	


	
	//metoda za slanje poruka ka serveru
		public void SendMessage(String message)
		{		
			try {
				
				
				dataOutputStream = new DataOutputStream(
		                client.getOutputStream());
				dataOutputStream.writeUTF(message);
				dataOutputStream.flush();

			} catch (IOException e) {
				e.printStackTrace();
			}

		}
		// metoda za prijem poruka od servera
		public String RecieveMessage()
		{
			
			try {
				
				dataInputStream = new DataInputStream(client.getInputStream());
				String ret = dataInputStream.readUTF();
				
				
				return ret;
				
			} catch (IOException e) {
		
				e.printStackTrace();
			}
			
			return null;
			
		}
		
	
	
	
	
	
	
	
	
	
	}     
        // metoda koja se poziva sa naredbom finish(). služi da se uništi Activity
	protected void onDestroy() {
	    super.onDestroy();

	    credentials=null;
	    result=null;

	} 
	//difolt metoda
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
}

