package com.bankapp;

import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.X509EncodedKeySpec;

import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

import android.util.Base64;
import android.util.Log;
/** pomoćna klasa koja se koristi za enkripciju i dekripciju
 *   podataka
 */

public class Security {
	
	private String message;
    SecretKey AESkey=null;
    int i=0;
    byte [] AESkeyb;
	String result;
    String transferKey=null;
	
	
	
	 public static PublicKey getPublicKey(String text) {
	    	PublicKey publicKey = null;

		  try{
		    	
		    	byte [] key = Base64.decode(text, 0); //decodira String nazad u bajtove pomocu Base64 encodera
		    	KeyFactory keyFactory =null;
			
					keyFactory = KeyFactory.getInstance("RSA");       //pravi generator kljuca za rsa
				

		    	X509EncodedKeySpec publicKeySpec = new X509EncodedKeySpec(                  //kreira specifikaciju kljuca

		    	key);

				try {
					publicKey = keyFactory.generatePublic(publicKeySpec);          //kreira public key za rsa

				} catch (InvalidKeySpecException e) {
					e.printStackTrace();
				}	
		    			
		    	
		  } catch (NoSuchAlgorithmException e) {
				e.printStackTrace();
			}
		    	
	    	return publicKey;

	 }    
		  //metoda kreira AES ključ 
	 
	 public byte[] createKeyForAES()
		      throws NoSuchAlgorithmException, NoSuchProviderException {
		   
	   SecureRandom random = new SecureRandom();                            // kreira generatator slučajnih brojeva 
		 KeyGenerator generator = KeyGenerator.getInstance("AES");          //kreira generator ključa za algoritam AES
		    generator.init(256, random);                                   //postavlja generator ključa na dužinu 256 bita i dodaje mu generator slučajnih brojeva
		   AESkeyb = generator.generateKey().getEncoded();                  //generiše ključ      
               	     Log.d("aes key",Base64.encodeToString(AESkeyb, 0));
	               
               	  
		    return AESkeyb;
		  }
	 
	 
	 //ova metoda skladišti RSA ključ u primenljivu
	 
    public void setPublicKey(String text){
    	
    	
       message = text;	
    	
    	
    }
    
	 
	 // metoda enkriptuje AES ključ pomoću dobijenog RSA ključa
    
	 public String encryptRSA(byte[] aesKey) throws Exception {

		 Cipher cipher=null;

		 String KeyEnc=null;
		 
		 byte[] cipherData = null;

		 cipher = Cipher.getInstance("RSA/ECB/PKCS1Padding");       //kreira šifrat za RSA algoritam

		 cipher.init(Cipher.ENCRYPT_MODE, getPublicKey(message));          //inicira mod za enkripciju i povlači vrednost RSA javnog ključa 
                                                                           //pomoću metode getPublicKey
		 cipherData = cipher.doFinal(aesKey);                          //doFinal izvršava enkripciju AES ključa
		 
		 KeyEnc = Base64.encodeToString(cipherData, 0);                // enkodira enkriptovani AES ključ u string  
		 
			
			Log.d("encrypted RSA key", KeyEnc);

		 return KeyEnc;

		 }
     // ova metoda vrši enkripciju podataka AES ključem         
	 
	 public String encrypt(String text) throws Exception {
		 
		 
		 Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");    //kreira sifrat za AES algoritam, u CBC modu i prema PKCS5 standardu
		    byte[] keyBytes = new byte[16];                             //definiše niz od 16 bajtova   
		    
		    int len = AESkeyb.length;                                   // definiše dužinu AES ključa
		    if (len > keyBytes.length)
		        len = keyBytes.length;
		    System.arraycopy(AESkeyb, 0, keyBytes, 0, len);
		    SecretKeySpec keySpec = new SecretKeySpec(keyBytes, "AES");
		    IvParameterSpec ivSpec = new IvParameterSpec(keyBytes);
		    cipher.init(Cipher.ENCRYPT_MODE, keySpec, ivSpec);          // inicira mod enkripcije i dodeljuje mu keySpec i ivSpec promenljive


		    byte[] results = cipher.doFinal(text.getBytes("UTF-8"));     //završava enkripciju, podatke za enkripciju čita iz promenljive text       
		                                                                // koja je definisana kao ulazni parametar pri pozivanju metode
		    return Base64.encodeToString(results, 0);
		 
	 }
		 // ova metoda vrši enkripciju podataka AES ključem
	
	 public String decrypt(String data) throws Exception {
		 
		 Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");   //kreira sifrat za AES algoritam, u CBC modu i prema PKCS5 standardu
		    byte[] keyBytes = new byte[16];                            //definiše niz od 16 bajtova 
		   
		    int len = AESkeyb.length;                                    // definiše dužinu AES ključa
		    if (len > keyBytes.length)                                   // ukoliko je dužina AES ključa duža od predviđenih 16 bajtova
		        len = keyBytes.length;                                   //  biće ograničena  
		    System.arraycopy(AESkeyb, 0, keyBytes, 0, len);               // funkcija System.arraycopy kopira vrednost AES ključa u novu promenljivu keyBytes 
		    SecretKeySpec keySpec = new SecretKeySpec(keyBytes, "AES");       //definiše specifikaciju za AES ključ
		    IvParameterSpec ivSpec = new IvParameterSpec(keyBytes);           // definiše vektor za inicijalizaciju
		    cipher.init(Cipher.DECRYPT_MODE, keySpec,ivSpec);                // inicira mod dekripcije i dodeljuje mu keySpec i ivSpec promenljive

		    byte[] results = cipher.doFinal(Base64.decode(data, 0));          // završava dekripciju
		    return new String(results, "UTF-8");

		 }

}
