package com.server;
import java.io.*;
import java.net.Socket;
/** klasa koja je zadužena za komunikaciju, odnosno opsluživanje klijenta
 * 
 */

public class Worker {

	private Thread thread;
	private Socket socket;
	
	DataOutputStream dataOutputStream = null;
    DataInputStream dataInputStream = null;
	Message key=null;
    Security security = new Security();                   // definiše objekat pomoćne klase Security
    String credentials;
    
    // konstruktor koji se poziva pri definisanju objekta klase Worker 
	public Worker(Socket soc) {
		
		socket = soc;
		
		thread = new Thread(new Runnable(){      // definisanje nove niti u okviru koje će se odvijati
		      @Override                          // komunikacija sa klijentom
			public void run() {
		        Run();
		      }
		    });
		thread.start();                           // pokretanje niti
	}

	public void Run()                            // metoda koja se pokreće iz konstruktora, odnosno po 
	{                                            // kreiranju niti 
		
		try {
			
			
		} catch (Exception e1) {
			
			e1.printStackTrace();
		}
		
		try
		{
		while(true)
		{
			Message message = RecieveMessage();          // server prima poruku od klijenta pomoću metode ReceiveMessage
			                                             // zavisno od komande koju dobije skače na određeni deo koda   
		                                            
			if (message.message.equals("Start"))
			{
				System.out.print("Start OK\n");
				SendMessage(new Message("Start OK"));                 // šalje poruku da je uspešno pokrenuta komunikacija
                 
				SendMessage(new Message(security.getPublicKey()));     // šalje RSA public key klijentu 
				
 				
			}
			
			if (message.message.equals("Key")){
				
				SendMessage(new Message("Key OK"));                     // šalje poruku da je spreman da prihvati AES ključ

				
				key = RecieveMessage();                                 // prima AES ključ od klijenta   
				System.out.print("Encripted AES:\n");
				System.out.print(key.message+"\n");

				
                security.decryptRSA(key.message);                       // decryptRSA metoda dekriptuje AES ključ primljen od klijenta  
			
				
				SendMessage(new Message("Key Ready"));                  // šalje poruku da je uspešno primio ključ  

				
			}
			
			
				if (message.message.equals("LogIn")){
					System.out.print("LogIn OK\n");
					
					SendMessage(new Message("LogIn OK"));               // šalje poruku da je spreman da prihvati kredencijale            
			
					
					message = RecieveMessage();
				
					try{
						
						
						
					credentials = security.decrypt(message.message);     // decrypt metoda dekriptuje AES ključem.
					
					}
					catch(Exception e){
						
						System.out.print(e.getMessage());
					}
					
					String[] usrPass = credentials.split(":");           // razdvaja primljeni string prema simbolu ":" na niz stringova
					String username = usrPass[0];                         // prvi string u nizu dodeljuje promenljivoj username
					String password = usrPass[1];
					System.out.print(username+" "+password+"\n");
					
					
					// proverava postojanje kredencijala u bazi
					boolean logInSuccessful = DBHandler.LogInProcedure(username, password);
					
					if(logInSuccessful)
					{
						
						SendMessage(new Message("Log in OK"));             //šalje poruku da je login uspešan
						System.out.print("Log in OK\n");
					}
					else
					{
						SendMessage(new Message("Log in FAIL"));           // šalje poruku da je login neuspešan
						System.out.print("Log in FAIL");
					}
					
				}
				if (message.message.equals("ClientData"))                   
				{
					
					SendMessage(new Message("ClientData OK"));               //šalje poruku da je spreman da pošalje podatke korisnika
					System.out.print("ClientData OK\n");
					
				    message = RecieveMessage();
					String credentials = security.decrypt(message.message);        // ponovo prima kredencijale i dekriptuje ih
					String[] usrPass = credentials.split(":");                     // razdvaja primljeni string
					String username = usrPass[0];
					String password = usrPass[1];
					String result = DBHandler.SendData(username, password);		    // metodom SendData iščitava podatke iz baze
					
					String res = security.encrypt(result);                          // enkriptuje podatke AES ključem
					SendMessage(new Message(res));                                  // šalje podatke klijentu
			
                    }
		
				
				
				if(message.message.equals("End"))
				{
					System.out.print("End OK\n");
					SendMessage(new Message("End OK"));                             // šalje poruku da je primio komandu za kraj komunikacije
					
					break;                                                           //iskače iz petlje
				}
			
				
				
				
			
		}}
		catch(Exception e)
		{
			System.out.println("client is off");
		}
	}
	

	
	
	public void SendMessage(Message message)
	{		
		try {
			
			
			dataOutputStream = new DataOutputStream(
	                socket.getOutputStream());
			dataOutputStream.writeUTF(message.message);
			dataOutputStream.flush();

		} catch (IOException e) {
			e.printStackTrace();
		}

	}
	
	public Message RecieveMessage()
	{
		
		try {
			
			dataInputStream = new DataInputStream(socket.getInputStream());
			Message ret = new Message(new String (dataInputStream.readUTF()));
			
			
			return ret;
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return null;
		
	}
}
